/***************************************************************************
 *   Copyright (C) 2009 by Stanson <stanson@pangolin.ru>                   *
 *   GPL v3 code, read COPYING file                                        *
 **************************************************************************/
#include <pic18fregs.h>
#include "main.h"
#include "config.h"

#include "ethernet_tx.h"

word delay_ms;

#pragma stack 0x0C0 64

#pragma code _reset 0x0000
void _reset (void) __naked
{
    __asm	GOTO _main		__endasm;
}

#pragma code _high_ISR 0x0008
void _high_ISR (void) __naked
{
    __asm	GOTO _high_interrupt	__endasm;
}

#pragma code _low_ISR 0x0018
void _low_ISR (void) __naked
{
    __asm	GOTO _low_interrupt	__endasm;
}


void high_interrupt(void) __interrupt
{
}

void low_interrupt(void) __interrupt
{
    if( PIR1bits.TMR1IF ) etx_process();
}

void main(void)
{
    __asm
    LFSR 1, _stack_end
    LFSR 2, _stack_end
    __endasm;

    /*   */

    ADCON1 = 0x7F;

    /*   (16 , CLK 5  (40  / 4 / 2) 0.2 ) */
    T0CON = 0x80;
    SET_TMR0_uS(1000);
    INTCONbits.TMR0IF = 0;

    delay_ms = 1000;
    
    /*    */
    etx_init();

    
    /* enable interrupts */
    RCONbits.IPEN = 1;
    INTCONbits.GIEL = 1;
    INTCONbits.GIEH = 1;

    while(1)
    {
	if(INTCONbits.TMR0IF)
	{ /*   (1 mS) */
	    /*     1000  */
	    SET_TMR0_uS(1000);
	    INTCONbits.TMR0IF = 0;

	    if(--delay_ms == 0)
	    {
		delay_ms = 1000;

		etx_frame.payload[ ETX_DATA_OFFSET +  0 ] = PORTA;
		etx_frame.payload[ ETX_DATA_OFFSET +  1 ] = PORTB;
		/* ... */
		etx_frame.payload[ ETX_DATA_OFFSET + 17 ] = RCONbits.TO;
		etx_send_data();
	    }

	    __asm	CLRWDT	__endasm;
	}
    }
}
